MATERIAL1 = 'materials/particle/fire.vmt' 
MATERIAL2 = 'materials/particle/particle_noisesphere.vmt' 
MATERIAL3 = 'materials/Effects/fleck_cement1.vmt' 
MATERIAL4 = 'materials/Sprites/heatwavedx70.vmt'
#
import es, cfglib, os, random, usermsg, gamethread
# 
gamename = str(es.ServerVar('eventscripts_gamedir')).rsplit(os.sep,1)[~0]
#
TrailEffects = ['smoke','energy','sparks','dust','beam']
#
WeaponEntityList = {}
#
class EntityManager(object):
    class Entity:
        def __init__(self, entity, name):
            self.entity = entity
            self.name = name
            self.indexes = {}
            self.teams = {}
            #
        def findIndexes(self):
            entlist = es.createentitylist(self.entity)
            remove = []
            for index in self.indexes:
                if not index in entlist:
                    remove.append(index)
            for index in remove:
                del self.indexes[index]
            for index in entlist:
                if not index in self.indexes:
                    self.indexes[index] = self.Index(index,self.teams[self.getTeamNum(index)],self.entity)
                if self.indexes[index].effect is None: continue
                self.indexes[index].createTrail()
                #
        @staticmethod
        def getTeamNum(index):
            teamnum = es.getindexprop(index,'CBaseEntity.m_iTeamNum')
            if teamnum: return teamnum
            owner = es.getindexprop(index,'CBaseEntity.m_hOwnerEntity')
            for userid in es.getUseridList():
                if es.getplayerhandle(userid) == owner: return es.getplayerteam(userid)
            if 0 in self.teams: return 0
            return random.choice([x for x in self.teams])
            #
        class Index:
            def __init__(self,index,team,entity):
                self.index = index
                self.teamname = team
                self.entity = entity
                self.location = es.getindexprop(self.index,'CBaseEntity.m_vecOrigin')
                self.effect = self.getEffect(str(es.ServerVar('%s_effect_%s'%(self.teamname,self.entity))).lower())
                #
            def createTrail(self):
                location = es.getindexprop(self.index,'CBaseEntity.m_vecOrigin')
                if location == self.location: return
                if self.effect == 'smoke':
                    es.effect('smoke',location,'smoke',5,.1)
                if self.effect == 'energy':
                    es.effect('energysplash',self.location,location,0)
                if self.effect == 'sparks':
                    es.effect('sparks',self.location,1,5,location)
                if self.effect == 'dust':
                    es.effect('dust',self.location,location,5,.1)
                if self.effect == 'beam':
                    colors = str(es.ServerVar('%s_beamcolor_%s'%(self.teamname,self.entity))).split(',')
                    if not len(colors) == 3: return
                    model = es.precachemodel(es.ServerVar('beammodel'))
                    width = es.ServerVar('beamwidth')
                    es.effect('beam',self.location,location,model,model,0,0,.1,width,width,.1,1,colors[0],colors[1],colors[2],255,30)
                self.location = location
                #
            @staticmethod
            def getEffect(effect):
                if not effect in TrailEffects + ['random']: return None
                if effect == 'random': return random.choice(TrailEffects)
                return effect
                #
    class Teams:
        def __init__(self, number, name):
            self.number = number
            self.name = name
            self.team_entities = {}
            #
        def _registerTeamEntity(self, entity, name):
            self.team_entities[entity] = name
            #
    def __init__(self):
        self.entities = {}
        self.teams = {}
        #
    def _registerTeam(self, number, name):
        self.teams[number] = self.Teams(number, name)
        #
    def _registerEntity(self, entity, name, teams):
        ent = self.entities[entity] = self.Entity(entity, name)
        teams = (teams,) if isinstance(teams, int) else tuple(teams)
        for team in teams:
            ent.teams[team] = self.teams[team].name.replace(' ','_').lower()
            self.teams[team]._registerTeamEntity(entity, name)
            #
    def findEntityIndexes(self):
        for entity in self.entities:
            self.entities[entity].findIndexes()
            #
hl2mp = EntityManager()
hl2mp._registerTeam(0,'Death Match')
hl2mp._registerTeam(2,'Rebels')
hl2mp._registerTeam(3,'Combine')
hl2mp._registerEntity('crossbow_bolt','Crossbow Bolts',(0,2,3))
hl2mp._registerEntity('grenade_ar2','SMG Grenade',(0,2,3))
hl2mp._registerEntity('npc_grenade_frag','Frag Grenade',(0,2,3))
hl2mp._registerEntity('rpg_missile','Rocket',(0,2,3))
hl2mp._registerEntity('prop_combine_ball','AR2 Ball',(0,2,3))
hl2mp._registerEntity('slam','SLAM',(0,2,3))
hl2mp._registerEntity('stunstick','STUN STICK',(0,2,3))
hl2mp._registerEntity('crowbar','CROW BAR',(0,2,3))
#
def _getCurrentGame():
    #
    if gamename == 'hl2mp':
        return hl2mp
    else:
        raise NotImplementedError, 'LooneyTrails does not currently support "%s"'%gamename
        #
currentgame = _getCurrentGame()
#
def load():
    es.msg('loaded') 
    addDownloadables()
    #
    es.addons.registerTickListener(tick)
    config = cfglib.AddonCFG(es.getAddonPath('x') + '/config.cfg')
    config.text(getCfgText('Weapon Entity Effect Options'))
    config.text('Possible choices for effects are "%s", and "random"'%'", "'.join(TrailEffects))
    config.text('Simply setting an effect to ANYTHING not listed above will mean there will be no effect for that entity.')
    config.text('Choosing "random" will mean each time a new entity is created of that type, it will choose a random effect for that index')
    config.text('')
    config.text('If you choose "beam" for any effect, please set the Red, Green, and Blue values for that entity')
    config.text('Please make sure when setting colors to use the format:\n// <variable> "<red>,<green>,<blue>"')
    for x in currentgame.teams:
        config.text('\n\n')
        team = currentgame.teams[x]
        config.text(getCfgText('    Choose Effects for %s Weapons    '%team.name))
        for entity in team.team_entities:
            config.text('\n')
            config.text('******** %s %s ********'%(team.name,team.team_entities[entity]))
            y = config.cvar('%s_effect_%s'%(team.name.replace(' ','_').lower(),entity),TrailEffects[0],'Set to the effect you wish %s to have for %s'%(team.name,team.team_entities[entity]))
            z = config.cvar('%s_beamcolor_%s'%(team.name.replace(' ','_').lower(),entity),'255,255,255','Set the "<red>,<green>,<blue>" values for %s beam color for %s'%(team.name,team.team_entities[entity]))
    config.text('\n\n')
    config.text(getCfgText('Beam Options'))
    beammodel = config.cvar('beammodel','sprites/laser.vmt','Set to model to use for beam effect')
    beamwidth = config.cvar('beamwidth',10,'Set to the width of the beam effect (default = 10)')
    config.write()
    config.execute()
    #
    for userid in es.getUseridList():
       disableAutokick(userid)
       #
def player_activate(event_var):
    disableAutokick(event_var['userid'])
    #
def disableAutokick(userid):
    es.server.mp_disable_autokick(userid)
    #
def addDownloadables():
    es.stringtable('downloadables', MATERIAL1)
    es.stringtable('downloadables', MATERIAL1[:-3] + 'vtf')
    es.stringtable('downloadables', MATERIAL2)
    es.stringtable('downloadables', MATERIAL2[:-3] + 'vtf')
    es.stringtable('downloadables', MATERIAL3)
    es.stringtable('downloadables', MATERIAL3[:-3] + 'vtf')
    es.stringtable('downloadables', MATERIAL4)
    es.stringtable('downloadables', MATERIAL4[:-3] + 'vtf')
    #
def es_map_start(ev):
    addDownloadables()
    #
def player_death(ev):
    weapon = ev["weapon"]
    attacker = ev["attacker"]
    userid = ev["userid"]
    #
    if weapon == "pistol":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'env_Smokestack')
	es.fire(userid, 'env_Smokestack', 'AddOutPut', 'targetname super357')
	es.fire(userid, 'env_Smokestack', 'AddOutPut', 'classname super357')
	es.fire(userid, 'super357', 'AddOutPut', 'basespread 15')
	es.fire(userid, 'super357', 'AddOutPut', 'spreadspeed 100')
	es.fire(userid, 'super357', 'AddOutPut', 'speed 50')
	es.fire(userid, 'super357', 'AddOutPut', 'startsize 15')
	es.fire(userid, 'super357', 'AddOutPut', 'endsize 25')
	es.fire(userid, 'super357', 'AddOutPut', 'rate 200')
	es.fire(userid, 'super357', 'AddOutPut', 'jetlength 500')
	es.fire(userid, 'super357', 'AddOutPut', 'twist 5')
	es.fire(userid, 'super357', 'AddOutPut', 'SmokeMaterial Effects/redflare.vmt')
	es.fire(userid, 'super357', 'AddOutPut', 'angles 90 90 90')
	es.fire(userid, 'super357', 'AddOutPut', 'rendercolor 220 100 110')
	es.fire(userid, 'super357', 'turnon')
	gamethread.delayed(1.3, es.fire, (userid, 'super357', 'turnoff'))
	gamethread.delayed(1.3, es.fire, (userid, 'super357', 'kill'))
        #
    if weapon == "357":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'env_Smokestack')
	es.fire(userid, 'env_Smokestack', 'AddOutPut', 'targetname super357')
	es.fire(userid, 'env_Smokestack', 'AddOutPut', 'classname super357')
	es.fire(userid, 'super357', 'AddOutPut', 'basespread 15')
	es.fire(userid, 'super357', 'AddOutPut', 'spreadspeed 100')
	es.fire(userid, 'super357', 'AddOutPut', 'speed 50')
	es.fire(userid, 'super357', 'AddOutPut', 'startsize 15')
	es.fire(userid, 'super357', 'AddOutPut', 'endsize 25')
	es.fire(userid, 'super357', 'AddOutPut', 'rate 200')
	es.fire(userid, 'super357', 'AddOutPut', 'jetlength 500')
	es.fire(userid, 'super357', 'AddOutPut', 'twist 5')
	es.fire(userid, 'super357', 'AddOutPut', 'SmokeMaterial effects/bluespark.vmt')
	es.fire(userid, 'super357', 'AddOutPut', 'angles 90 90 90')
	es.fire(userid, 'super357', 'AddOutPut', 'rendercolor 220 100 110')
	es.fire(userid, 'super357', 'turnon')
	gamethread.delayed(1.3, es.fire, (userid, 'super357', 'turnoff'))
	gamethread.delayed(1.3, es.fire, (userid, 'super357', 'kill'))
        #
    if weapon == "shotgun":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'point_spotlight')
	es.fire(userid, 'point_spotlight', 'AddOutPut', 'targetname spotlightshotgun')
	es.fire(userid, 'point_spotlight', 'AddOutPut', 'classname spotlightshotgun')
	es.fire(userid, 'spotlightshotgun', 'AddOutPut', 'HDRColorScale 0 255 0')
	es.fire(userid, 'spotlightshotgun', 'AddOutPut', 'spotlightlength 2000')
	es.fire(userid, 'spotlightshotgun', 'AddOutPut', 'spotlightwidth 30')
	es.fire(userid, 'spotlightshotgun', 'AddOutPut', 'angles -89.000000 103.046318 0.000000')
	es.fire(userid, 'spotlightshotgun', 'LightOn')
	es.fire(userid, 'spotlightshotgun', 'color "0 0 255"')
	es.fire(userid, 'beam', 'AddOutPut', 'targetname spotlightshotgunbeam')
	es.fire(userid, 'beam', 'AddOutPut', 'classname spotlightshotgunbeam')
	es.fire(userid, 'spotlightshotgunbeam', 'noise 0')
	es.fire(userid, 'spotlightshotgunbeam', 'width 55')
	es.fire(userid, 'spotlightshotgunbeam', 'color "255 255 0"')
	gamethread.delayed(1.3, es.fire, (userid, 'spotlightshotgun', 'LightOff'))
	gamethread.delayed(1.3, es.fire, (userid, 'spotlightshotgun', 'kill'))
	gamethread.delayed(1.6, es.fire, (userid, 'spotlightshotgunbeam', 'kill'))
        #
    if weapon == "crossbow_bolt":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'point_spotlight')
	es.fire(userid, 'point_spotlight', 'AddOutPut', 'targetname spotlightcrossbow_bolt')
	es.fire(userid, 'point_spotlight', 'AddOutPut', 'classname spotlightcrossbow_bolt')
	es.fire(userid, 'spotlightcrossbow_bolt', 'AddOutPut', 'HDRColorScale 0 255 0')
	es.fire(userid, 'spotlightcrossbow_bolt', 'AddOutPut', 'spotlightlength 2000')
	es.fire(userid, 'spotlightcrossbow_bolt', 'AddOutPut', 'spotlightwidth 30')
	es.fire(userid, 'spotlightcrossbow_bolt', 'AddOutPut', 'angles -89.000000 103.046318 0.000000')
	es.fire(userid, 'spotlightcrossbow_bolt', 'LightOn')
	es.fire(userid, 'spotlightcrossbow_bolt', 'color "0 0 255"')
	es.fire(userid, 'beam', 'AddOutPut', 'targetname spotlightcrossbow_boltbeam')
	es.fire(userid, 'beam', 'AddOutPut', 'classname spotlightcrossbow_boltbeam')
	es.fire(userid, 'spotlightcrossbow_boltbeam', 'noise 0')
	es.fire(userid, 'spotlightcrossbow_boltbeam', 'width 55')
	es.fire(userid, 'spotlightcrossbow_boltbeam', 'color "255 255 0"')
	gamethread.delayed(1.3, es.fire, (userid, 'spotlightcrossbow_bolt', 'LightOff'))
	gamethread.delayed(1.3, es.fire, (userid, 'spotlightcrossbow_bolt', 'kill'))
	gamethread.delayed(1.6, es.fire, (userid, 'spotlightcrossbow_boltbeam', 'kill'))
        #
    if weapon == "ar2":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'env_fire')
	es.fire(userid, 'env_fire', 'AddOutPut', 'firesize 9999')
	es.fire(userid, 'env_fire', 'AddOutPut', 'health 1')
	es.fire(userid, 'env_fire', 'AddOutPut', 'fireattack 5')
	es.fire(userid, 'env_fire', 'AddOutPut', 'firetype plasma')
	es.fire(userid, 'env_fire', 'AddOutPut', 'damagescale 0')
	es.fire(userid, 'env_fire', 'StartFire')
	gamethread.delayed(1.3, es.fire, (userid, 'env_fire', 'kill'))
        #
    if weapon == "smg1":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'env_steam')
	es.fire(userid, 'env_steam', 'AddOutPut', 'SpreadSpeed 1000')
	es.fire(userid, 'env_steam', 'AddOutPut', 'Speed 100')
	es.fire(userid, 'env_steam', 'AddOutPut', 'StartSize 1')
	es.fire(userid, 'env_steam', 'AddOutPut', 'EndSize 1000')
	es.fire(userid, 'env_steam', 'AddOutPut', 'Rate 100')
	es.fire(userid, 'env_steam', 'AddOutPut', 'JetLength 1000')
	es.fire(userid, 'env_steam', 'AddOutPut', 'rendercolor 255 0 255')
	es.fire(userid, 'env_steam', 'AddOutPut', 'rollspeed 1')
	es.fire(userid, 'env_steam', 'TurnOn')
	gamethread.delayed(1.3, es.fire, (userid, 'env_steam', 'TurnOff'))
	gamethread.delayed(1.3, es.fire, (userid, 'env_steam', 'kill'))
        #
    if weapon == "crowbar":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        #
    if weapon == "stunstick":
        usermsg.shake(attacker, 3.1, 5)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'point_tesla')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'm_Color 0 200 11')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'm_flRadius 600')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'beamcount_min 1000')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'beamcount_max 6000')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'thick_min 1')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'thick_max 11')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'lifetime_min .1')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'lifetime_max .4')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'interval_min .1')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'interval_max .2')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'texture sprites/lgtning.vmt')
	es.fire(userid, 'point_tesla', 'DoSpark')
	gamethread.delayed(0.1, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.2, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.3, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.4, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.5, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.6, es.fire, (userid, 'point_tesla', 'Kill'))
        #
    if weapon == "slam":
        usermsg.shake(attacker, 3.1, 6)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
        fragcloud2(userid)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
        #
    if weapon == "frag":
        usermsg.shake(attacker, 3.1, 6)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
        fragcloud3(userid)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
        #
    if weapon == "combine_ball":
        usermsg.shake(attacker, 3.1, 7)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
        fragcloud1(userid)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
	es.give(userid, 'point_tesla')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'm_Color 255 71 36')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'm_flRadius 1000')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'beamcount_min 1000')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'beamcount_max 6000')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'thick_min 10')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'thick_max 6')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'lifetime_min .1')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'lifetime_max .4')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'interval_min .1')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'interval_max .2')
	es.fire(userid, 'point_tesla', 'AddOutPut', 'texture sprites/lgtning.vmt')
	es.fire(userid, 'point_tesla', 'DoSpark')
	gamethread.delayed(0.1, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.2, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.3, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.4, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.5, es.fire, (userid, 'point_tesla', 'DoSpark'))
	gamethread.delayed(0.6, es.fire, (userid, 'point_tesla', 'Kill'))
        #
    if weapon == "smg1_grenade":
        usermsg.shake(attacker, 5.1, 7)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
        fragcloud2(userid)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
        #
    if weapon == "grenade_frag":
        usermsg.shake(attacker, 7.3, 7)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
        fragcloud3(userid)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
        #
    if weapon == "rpg_missile":
        usermsg.shake(attacker, 9.5, 7)
        usermsg.fade(attacker, 1, 0.15, 0, 255, 11, 11, 160)
        fragcloud4(userid)
	es.give(userid, 'env_blood')
	es.fire(userid, 'env_blood', 'AddOutPut', 'amount 9999')
	es.fire(userid, 'env_blood', 'EmitBlood')
	gamethread.delayed(1.3, es.fire, (userid, 'env_blood', 'kill'))
        es.fire(userid, "!self", "IgniteLifetime", 1.0)
        #
def fragcloud1(userid):
    clouds = es.createentitylist("env_ar2explosion")
    es.server.queuecmd("es_xgive %s env_ar2explosion"% userid)
    es.server.queuecmd("es_fire %s env_ar2explosion addoutput \"material %s\""% (userid, MATERIAL1.split('/', 1)[1]))
    es.server.queuecmd("es_fire %s env_ar2explosion explode"% userid)
    gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s env_ar2explosion Kill"% userid))
    for cloud in clouds:
        gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s %s Kill"% (userid, cloud)))
        #
def fragcloud2(userid):
    clouds = es.createentitylist("env_ar2explosion")
    es.server.queuecmd("es_xgive %s env_ar2explosion"% userid)
    es.server.queuecmd("es_fire %s env_ar2explosion addoutput \"material %s\""% (userid, MATERIAL2.split('/', 1)[1]))
    es.server.queuecmd("es_fire %s env_ar2explosion explode"% userid)
    gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s env_ar2explosion Kill"% userid))
    for cloud in clouds:
        gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s %s Kill"% (userid, cloud)))
        #
def fragcloud3(userid):
    clouds = es.createentitylist("env_ar2explosion")
    es.server.queuecmd("es_xgive %s env_ar2explosion"% userid)
    es.server.queuecmd("es_fire %s env_ar2explosion addoutput \"material %s\""% (userid, MATERIAL3.split('/', 1)[1]))
    es.server.queuecmd("es_fire %s env_ar2explosion explode"% userid)
    gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s env_ar2explosion Kill"% userid))
    for cloud in clouds:
        gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s %s Kill"% (userid, cloud)))
        #
def fragcloud4(userid):
    clouds = es.createentitylist("env_ar2explosion")
    es.server.queuecmd("es_xgive %s env_ar2explosion"% userid)
    es.server.queuecmd("es_fire %s env_ar2explosion addoutput \"material %s\""% (userid, MATERIAL4.split('/', 1)[1]))
    es.server.queuecmd("es_fire %s env_ar2explosion explode"% userid)
    gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s env_ar2explosion Kill"% userid))
    for cloud in clouds:
        gamethread.delayed(0.1, es.server.queuecmd, ("es_fire %s %s Kill"% (userid, cloud)))
        #
def player_spawn(ev):
    for index in weaponlib.getIndexList("env_ar2explosion"):
        if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
            es.server.queuecmd('es_xremove %s' % index)
            #
def getCfgText(text):
    return '%s\n// ** %s **\n// %s'%('*'*(len(text) + 6),text,'*'*(len(text) + 6))
    #
def unload():
    es.msg('unloaded')
    #
    es.addons.unregisterTickListener(tick)
    #
def tick():
    currentgame.findEntityIndexes()
    #
    #
    #